#include<bits/stdc++.h>
using namespace std;
#define LINF 1000000000000000000
long long dp[2050][2050];
int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n,m;
	cin>>n>>m;
	long long mat[n][m];
	for(int i=0;i<n;i++){
		for(int j=0;j<m;j++) cin>>mat[i][j];
	}
	int q;
	cin>>q;
	while(q--){
	int a,b;
	cin>>a>>b;
	a--;
	b--;
	int x = mat[a][b];
	mat[a][b] = LINF;
	dp[0][0] = mat[0][0];
	for(int i=1;i<n;i++) dp[i][0] = dp[i-1][0]+mat[i][0];
	for(int i=1;i<m;i++) dp[0][i] = dp[0][i-1]+mat[0][i];
	for(int i=1;i<n;i++){
		for(int j=1;j<m;j++){
			dp[i][j] = min(dp[i-1][j],dp[i][j-1])+mat[i][j];
		}
	}
	cout<<dp[n-1][m-1]<<endl;
	mat[a][b] = x;
	}
}